
int Rad=MathRand();  
int MagicNumber=13579+Rad;
extern double OB=1.2;
extern double OS=1.1;
extern double Lots =0;
extern double StopLoss=0;
extern double TakeProfit=0;
extern int TrailingStop=0;
extern int Slippage=3;

//+------------------------------------------------------------------+
//    expert start function
//+------------------------------------------------------------------+
int start()
{
  double MyPoint=Point;
  if(Digits==3 || Digits==5) MyPoint=Point*10;
  
  double TheStopLoss=0;
  double TheTakeProfit=0;
  if( TotalOrdersCount()==0 ) 
  {
     int result=0;
     if(
           (Close[-1]>=OB)
         &&(iSAR(NULL,PERIOD_H4,0.02,0.2,-1)<iMA(NULL,0,5,0,MODE_LWMA,PRICE_WEIGHTED,-1))
         &&(iMA(NULL,0,5,0,MODE_LWMA,PRICE_WEIGHTED,-1)>iMA(NULL,0,50,0,MODE_LWMA,PRICE_WEIGHTED,-1))
         &&(iRSI(NULL,0,5,PRICE_CLOSE,-1)>77)
         &&(iStochastic(NULL,PERIOD_D1,17,3,3,MODE_LWMA,1,MODE_MAIN,-1)>20)
         &&(iStochastic(NULL,PERIOD_H4,25,3,3,MODE_LWMA,1,MODE_MAIN,-1)>20)
        
     ) // Here is your open buy rule
     
     {
         Alert("BUY Signal "+ Symbol() + " Timeframe " + Period()+ " " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
         SendNotification("Buy Signal "+ Symbol() + " Timeframe " + Period()+ " " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
         PlaySound("alert.wav");
        result=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,"My EA",MagicNumber,0,Blue);
        if(result>0)
        {
         TheStopLoss=0;
         TheTakeProfit=0;
         if(TakeProfit>0) TheTakeProfit=Ask+TakeProfit*MyPoint;
         if(StopLoss>0) TheStopLoss=Ask-StopLoss*MyPoint;
         OrderSelect(result,SELECT_BY_TICKET);
         OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green);
        }
        return(0);
     }
     if(
           (Close[-1]>=OS)
         &&(iSAR(NULL,PERIOD_H4,0.02,0.2,-1)>iMA(NULL,0,5,0,MODE_LWMA,PRICE_WEIGHTED,-1))
         &&(iMA(NULL,0,5,0,MODE_LWMA,PRICE_WEIGHTED,-1)<iMA(NULL,0,50,0,MODE_LWMA,PRICE_WEIGHTED,-1))
         &&(iRSI(NULL,0,5,PRICE_CLOSE,-1)<23)
         &&(iStochastic(NULL,PERIOD_D1,17,3,3,MODE_LWMA,1,MODE_MAIN,-1)<80)
         &&(iStochastic(NULL,PERIOD_H4,25,3,3,MODE_LWMA,1,MODE_MAIN,-1)<80)
         
         ) // Here is your open Sell rule
     
     {
         Alert("SELL Signal "+ Symbol() + " Timeframe " + Period()+ " " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
         SendNotification("SELL Signal "+ Symbol() + " Timeframe " + Period()+ " " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
         PlaySound("alert.wav");
        result=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,"My EA",MagicNumber,0,Red);
        if(result>0)
        {
         TheStopLoss=0;
         TheTakeProfit=0;
         if(TakeProfit>0) TheTakeProfit=Bid-TakeProfit*MyPoint;
         if(StopLoss>0) TheStopLoss=Bid+StopLoss*MyPoint;
         OrderSelect(result,SELECT_BY_TICKET);
         OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green);
        }
        return(0);
     }
  }
  
  for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber 
         )  
        {
         if(OrderType()==OP_BUY)  
           {
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>MyPoint*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-MyPoint*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*MyPoint,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(MyPoint*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+MyPoint*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+MyPoint*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
}

int TotalOrdersCount()
{
  int result=0;
  for(int i=0;i<OrdersTotal();i++)
  {
     OrderSelect(i,SELECT_BY_POS ,MODE_TRADES);
     if (OrderMagicNumber()==MagicNumber+Rad) result+=1;

   }
  return (result);
}
